module vstrings;

struct ContextHelp {
	const string title;
	const string[] text;
}


//const string[] HELPMAIN =
const ContextHelp HELPMAIN = ContextHelp("Main help", 
["
Escape (x2).....Quit Program
F10.............Open the Load song dialog
F11.............Open the Save song dialog
F9..............Open the About dialog
Ctrl-F11........Quick save song (doesn't ask a filename)

`+dPlayback\n
F1..............Play from playback mark
Shift-F1........Play / resume from mark with tracking
F2..............Play from the start
Shift-F2........Play / resume from the start with tracking
F3..............Play from cursor position
F4..............Stop playback
F8..............Fast forward (w/ Shift = Fast forward more)
Scroll Lock.....Start/stop tracking (works only when playing)
Ctrl-1,2,3......Toggle voices on/off
Ctrl-F9.........Show/hide SID registers dump

`+dSong variables\n
Ctrl-Keypad - +.........Decrease/increase default song speed
[ ].....................Decrease/increase default song speed
Alt-Keypad - +..........Decrease/increase multispeed framecall counter 
{ }.....................Decrease/increase multispeed framecall counter
Ctrl-F3.................Toggle SID type (6581/8580)
Ctrl-F8.................Select next SID filter preset
Ctrl-Shift-F8...........Select previous SID filter preset
Alt-T...................Edit title / author / release info
Alt-Keypad 0 (x2).......Clear sequences (press TWICE to activate)
Ctrl-Alt-KP0 (x2).......Clear all (reset to defaults)
Alt-KP Del (x2).........Remove unused sequences & instruments
", "
`+dMoving between tables\n
Tab.....................Move cursor between subwindows
Ctrl-Tab................Move cursor between main windows
                        (sequencer, instrument table, subtables)
Alt-V...................Jump to Sequencer
Alt-I...................Jump to Instrument table
Alt-M...................Jump to Cmd table
Alt-P...................Jump to Pulse table
Alt-F...................Jump to Filter table
Alt-D...................Jump to Chord table
Alt-1,2,3...............Jump to voice 1, 2 or 3
Alt-4-8 can also move between tables (in the aforementioned order,
so Alt-4 = Sequencer, Alt-5 = Ins, ...)

`+dPlayer reference\n
Check out the player reference guide from the CheeseCutter homepage.

`+dCheeseCutter homepage:
http://theyamo.kapsi.fi/ccutter

"]);

const ContextHelp HELPSEQUENCER = ContextHelp("Sequencer help",
["`+1Press F12 again to see the global help

`+dGeneral

Alt-1,2,3...............Jump to voice 1, 2 or 3
Tab.....................Move cursor to the next voice

Keypad / *..............Decrease/increase base octave value
Ctrl-Keypad - +.........Decrease/increase default song speed
[ ].....................Decrease/increase default song speed
Keypad - +..............Decrease/increase active instrument number
Keypad 1-9..............Set cursor step value (used when entering notes)
Alt-Left/Right..........Activate previous/next subtune

F5......................Enter to the track column
Shift-F5................Display tracks alongside the sequences
F6......................Enter to the note column
F7......................Display tracks only (toggles on/off)

Home/End................Move cursor to SEQ start/end OR screen top/bottom
Shift-Home/End..........Move cursor to song start/end
Backspace...............Set playback start mark (the blue bar) to current position
Ctrl-Backspace..........Set playback wrap mark (the orange bar) to current position
Ctrl-Home/Ctrl-H........Jump to playback mark position

Alt-C...................Ask for a seq number and copy it over the current seq
Alt-A...................Ask for a seq number and insert it to cursor position
Alt-Z...................Ask for a number and copy the N of tracks into clipboard
Alt-B...................Paste copied tracks from the clipboard (overwrite)
(Shift-)Insert/Delete...Insert/delete a row (Shift=w/ sequence expand/shrink)
Ctrl-Insert/Delete......Expand/shrink the sequence
Shift-Enter.............Quick expand sequence (expands by highlight value * 4)
Shift-Q/A...............Transpose semitone up/down
","Ctrl-W/S................Transpose octave up/down
Ctrl-M/N................Increase/decrease row highlight value
Ctrl-0(zero)............Reset highlighting to current row
Ctrl-R..................Show/hide row counters for sequences
Ctrl-P (2x).............Split current sequence from cursor pos. `+dUse with caution.

`+dIn the note column (F6)

 2 3   5 6 7   9 0
Q W E R T Y U I O P.....Enter notes (base octave+1)
 S D   G H J
Z X C V B N M...........Enter notes (base octave)

1.......................Enter a gate off (===)
A or !..................Enter a gate on (+++)
Space or '.'............Clear
Space...................Insert previously entered instrument/command value
                        (in instrument/command column only)
- +.....................Decrease/increase base octave
';'.....................Do/do not insert instrument value automatically
','.....................Change the note in current row to a tie note
Enter...................'Pick up' the instrument value in the current row

`+dIn the track column (F5)

Ctrl-F..................Find next unused sequence starting from current value
< >.....................Select previous/next sequence
Ctrl-Q/A................Transpose all tracks up/down from cursor down
Space...................Write the cached sequence value to the track list
Shift-Insert/Delete.....Insert empty track (A000) or delete track from cursor
                        pos down
Ctrl-Insert/Delete......Insert/delete track to end of voice and move cursor there
Ctrl-Shift-Insert/Del...Insert/delete a track for all voices"]);

